
#  - CHATTERS ver 1.10 / Last updated on Mar 9, 2007
#  - (C)2007 WEB POWER. All Rights Reserved. <http://webpower.jp/>

use strict;


#--------------------------------------------------------------------------------
# * Sign out from the chat.
#
#     Called : main
#     Params : [ގbZ[W]
#     Return : ->Show_LogoutPage
#--------------------------------------------------------------------------------

sub Logout_Chat #($out_msg)
{

	#  
	my($out_msg) = @_;

	#  ! Ǐϐ錾
	my($roms_data, $user_data, $user_list, $chat_data, $chat_file, $link_file, $profiles);


	if ($::SYS{'CARRIER'} ne "o") {
		$chat_file = $::SYS{'CHAT_DIR'} . getFilename();

	#  t@Cn[hN̏ꍇ
	} elsif (substr($::SIO{'file'}, -5) eq ".link") {
		my($file_name) = $::SIO{'file'};

		#  n[hNt@CƖ{̃t@C̃pX擾 (RFSގɎ폜ہA{̃t@C폜Kv邽߁B)
		$file_name =~ tr/-+=A-Za-z0-9_.//cd;
		$link_file = "$::SYS{'CHAT_DIR'}$file_name.html";
		$file_name = getFilename();
		$chat_file = "$::SYS{'CHAT_DIR'}$file_name";
		Show_LogoutPage() if (!-f $link_file || !-s $link_file);

	#  t@Cʏt@C̏ꍇ
	} else {
		$chat_file = "$::SYS{'CHAT_DIR'}$::CHAT_ID.html";
	}

	#  t@C݂ȂΑގy[W
	if (!-f $chat_file || !-s $chat_file) {
		Show_LogoutPage() ;
	}


	# <t@CXVErtt@Co>

		if ($::SYS{'USE_LOCK'} && !stdio::lock($::LOCK_FILE)) {
			error('[A0A]r', "busy");
		}

		#   `bgt@Cǂݍ => QҊǗ
		($roms_data, $user_data, $user_list, $chat_data, $profiles) = (readChatFile($chat_file, $::SIO{'name'}))[0,1,2,3,6];

		#  Ogp (IDsv)
		if ($roms_data == -1) {
			stdio::unlock($::LOCK_FILE);
			Show_LogoutPage();

		#  ɑގς (Q҃f[^ɖOȂ)
		} elsif ($roms_data == -2) {
			stdio::unlock($::LOCK_FILE);
			Show_LogoutPage();

		#  Sގ  O폜ݒ
		} elsif ($user_data eq "" && $::INI{'auto_clear'}) {
			stdio::unlock($::LOCK_FILE);
			unlink $chat_file;

			#  n[hNt@CS폜 (Jg`bgΏ)
			if (opendir DIR, $::SYS{'CHAT_DIR'}) {
				while ($_ = readdir DIR) {
					unlink "$::SYS{'CHAT_DIR'}$_" if (/^$::CHAT_ID=\w+\+\w+\.\d+\.link\.html$/);
				}
				closedir DIR;
			}

		#  ʏގ => ގbZ[W
		} else {
			my($font_st, $font_et, $icon, $time_now, $talk_data, $result);

			#  F^OEݎEACR\^O̎擾
			($font_st, $font_et) = getFontColor($::SIO{'font'});
			$time_now = sprintf("%02d:%02d:%02d",(gmtime($::SYS{'TIME'} + 3600 * $::INI{'time_zone'}))[2,1,0]);
			$icon = getIcon($::SIO{'icon'});

			#  ގbZ[W̍쐬
			if (defined $out_msg) {
				$talk_data = qq|<div class="info"><span class="time">$time_now</span> $font_st<strong>&lt;ގ&gt;</strong> <strong>$::SIO{'name'}</strong> &gt; $out_msg$font_et</div>| if ($out_msg ne "");
			} else {
				$talk_data = qq|<div class="info"><span class="time">$time_now</span> $font_st<strong>&lt;ގ&gt;</strong> $::INI{'info_message3'}$font_et</div>|;
				$talk_data =~ s/\$NAME/$icon$::SIO{'name'}/;
			}
			$talk_data =~ s/&amp;#(\d{5}|xE7[A-Fa-f0-9]{2});/getImage($1)/egi;

			#   `bgt@Cɏ
			if (-e $link_file) {
				$result = outputTalkData($link_file, $roms_data, $user_data, $user_list, $chat_data, $talk_data, undef, $profiles);
			} else {
				$result = outputTalkData($chat_file, $roms_data, $user_data, $user_list, $chat_data, $talk_data, undef,$profiles);
			}

			stdio::unlock($::LOCK_FILE);

			if ($result < 0) {
				error('[A0C]t@Cs');
			}

			#  n[hNt@C΍폜
			unlink $link_file if (-e $link_file);
		}

	# </t@CXVErtt@Co>


	#  [bN
	if ($user_data eq "") {
		stdio::setSession("$::SYS{'DATA_DIR'}roomlock.dat", [], $::CHAT_ID, -1);
	}

	Show_LogoutPage();

}#Logout_Chat


#
#  ގy[W\
#
#     ďo : Login_Chat, Logout_Chat, Talk_Chat
#        : Ȃ
#     ߂l : I
#

sub Show_LogoutPage #(void)
{


	if ($::SIO{'status'} == 204) {
		header("Status: 204 No Content");
		exit;
	}

	#  gѓdb̏ꍇ
	mobile::Show_LogoutPage() if ($::SYS{'CARRIER'} ne "o");

	#  HTMLo͊Jn
	header("nocache");
	print <<__HTML__;
<?xml version="1.0" encoding="$::JCODE2" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
<base href="http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<meta http-equiv="Content-Script-Type" content="text/javascript" />
$::LINK_ELEMENT
<title>$::INI{'title'} [ގ]</title>
<script type="text/javascript">
<!--
function exitChat()
{
  if (window.top.name == "$::CHAT_ID") {
    window.top.close();
    return false;
  } else
    return true;
}
//-->
</script>
<style type="text/css">
<!--
body
{
  margin          : 0px;
  padding         : 0px;
}
-->
</style>
</head>
<body $::INI{'body'} class="logoutpage">
<h1 class="main">`bgގ</h1>

<div style="margin: 20px">
__HTML__

	#  ʏގ̏ꍇ
	if ($::SIO{'normal'}) {
		print <<__HTML__;
<h3>$::SIO{'name'} p肪Ƃ܂</h3>

<p>$::INI{'title'}ގ܂BЂ܂zB</p>

__HTML__

	#  ُގ̏ꍇ
	} else {
		print <<__HTML__;
<h3>܃`bg[ގԂɂȂĂ܂</h3>

<p> [ގ]{^ȂĂAȉ̂悤ȏꍇ͑ގɂȂ܂BȂ̗\\zɔđގɂȂꍇAȉ[ē]N`bgɍē邱Ƃł܂B</p>
<ul>
  <li>uEŰ@\\g[XV]Aʃy[WɈړB</li>
  <li>莞ԁAxȂB</li>
  <li>[}X^[A͊Ǘ҂`bg[̏sB</li>
  <li>[}X^[A͊Ǘ҂狭ގ󂯂B</li>
  <li>Ǘ҂ɂݒ肳Ă闘p\\Ԃ𒴉߂B</li>
</ul>

__HTML__
	}

	print <<__HTML__;
<hr />
<div align="center">
 a <a href="@{[$::INI{'url'} eq "http://" || $::INI{'url'} eq "" ? $::CFG{'url'} : $::INI{'url'}]}" target="_top" onclick="return exitChat()">I</a> a <a href="$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}?cmd=chat;code=$::SIO{'code'};file=$::SIO{'file'}" target="_top">ē</a> a
</div>
<hr />
__HTML__

	#  !! ̕𖳋ɍ폜E₂܂ƕsgp(쌠NQECZXᔽ)ƂȂ܂B
	#  !WARN! DO NOT REMOVE THIS PART. If you remove this part without a valid license, you infringe on copyright.
	print <<__HTML__;
<!-- Begin Copyright -->
<div style="text-align:right; font-family:'Arial';font-size:8pt;font-weight:bold">
  <a href="http://webpower.jp/" target="_blank" style="font-size:10pt;color:#00F;text-decoration:none" title="VXeJE^WEB POWER">$::VERSION</a><br />
  Powered by WEBPOWER
</div>
<!-- End Copyright   -->

</div>
</body>
</html>
__HTML__

	exit;

}#Show_LogoutPage

1;
