
#  - CHATTERS ver 1.10 / Last updated on Mar 9, 2007
#  - (C)2007 WEB POWER. All Rights Reserved. <http://webpower.jp/>

use strict;

#--------------------------------------------------------------------------------
# - Display talking page (displayed in frame)
#
#     Called : main
#     Params : void
#     Return : exit
#--------------------------------------------------------------------------------

sub Show_TalkingPage #(void)
{

	#  ! Local variables
	my(%disable, %able,
	   $dhtml, $font_color, $reload_interval, $enctype);


	delete $::SIO{'cmd'};

	#  Able to use HTML tags?
	if ($::INI{'allow_html'}) {
		if (!$::SIO{'nojs'} && (index($ENV{'HTTP_USER_AGENT'}, "MSIE 6") != -1 || index($ENV{'HTTP_USER_AGENT'}, "MSIE 7") != -1) && index($ENV{'HTTP_USER_AGENT'}, "Opera") == -1) {
			$dhtml = 1;
		} else {
			$able{html} = ' <input type="checkbox" name="html" value="2" accesskey="t" title="HTMLvf̈ꕔLɂȂA\Lȃ`bgyނƂł܂B" />HTMLL(<u>T</u>)';
		}
	}

	#  Able to send file?
	if ($::INI{'allow_upload'}) {
		$able{file} = qq|M(<u>A</u>) : <input type="file" name="attachment" size="20" title="莝̃t@C@{[getMeasure($::INI{'allow_upload'}*1024,0)]}B܂őMł܂B(HTMLEXEȂǈꕔ̃t@C͈S㑗Mł܂)" accesskey="a" />|;
		$enctype = ' enctype="multipart/form-data"';
	} else {
		$disable{file} = ' style="display:none"';
	}

	#  Use pictograph?
	if ($::INI{'use_pictograph'}) {
		$able{picto} = q|<input type="button" value="G" style="padding:2px" onclick="open_pictograph()" />|;
	} else {
		$disable{picto} = ' style="display:none"';
	}

	#  Use shake?
	if ($::INI{'use_shake'}) {
		$able{shake} = q|<input type="button" value="VFCNM" style="padding:2px" onclick="send_shake()" />|;
	} else {
		$disable{shake} = ' style="display:none"';
	}

	#  Use dice?
	if ($::INI{'use_dice'}) {
		$able{dice} = q|<input type="button" value="_CXU" style="padding:2px" onclick="throw_dice()" />|;
	} else {
		$disable{dice} = ' style="display:none"';
	}

	#  Use click input?
	if ($::INI{'use_clickinput'} && $::INI{'easy_input'}) {
		$able{click} = <<__HTML__;
<select class="click-input" name="oneClickInput" onchange="oneclickInput(this)">
          <option value="">NbNCvbg</option>
          <option value="--USERS--">-----------------------</option>
          <option value="--USERS--">-----------------------</option>
__HTML__
		foreach (split /[\r\n]/, $::INI{'easy_input'}) {
			s/&/&amp;/g;
			s/"/&quot;/g;
			s/</&lt;/g;
			s/>/&gt;/g;
			$able{click} .= qq|          <option value="$_">$_</option>\n|;
		}
		$able{click} .= qq|          </select>|;
	}

	#  [hԊuIZNgj[(ꕔ)쐬
	$::CFG{'reload_interval'} = '5,10,20d,30,60,90,120,180' if (!$::CFG{'reload_interval'});
	foreach (split /,/, $::CFG{'reload_interval'}) {
		if (substr($_, -1, 1) eq "d") {
			chop;
			$reload_interval .= qq|            <option value="$_" selected="selected">$_b</option>\n|;
		} else {
			$reload_interval .= qq|            <option value="$_">$_b</option>\n|;
		}
	}

	$::SIO{name} =~ s/&gt;/>/g;
	$::SIO{name} =~ s/&lt;/</g;
	$::SIO{name} =~ s/&quot;/"/g;
	$::SIO{name} =~ s/&amp;/&/g;

	#  HTML
	header("nocache");
	if ($dhtml) {  	#  for IE6/7
		print <<__HTML__;
<?xml version="1.0" encoding="$::JCODE2" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
<base href="http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<meta http-equiv="Content-Script-Type" content="text/javascript" />
$::LINK_ELEMENT
<title>$::INI{'title'}</title>
<script type="text/javascript">
var chat_uri = "$::SYS{'CHAT_DIR_URI'}$::SIO{'file'}.html?";
var docs_uri = "$::SYS{'DOCS_DIR_URI'}";
var send_uri = '$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}?@{[stdio::setQueryString(\%::SIO)]}';
var default_color= '$::SIO{'font'}';
</script>
<script type="text/javascript" src="$::SYS{'DOCS_DIR'}js/form_ie.js">
</script>
<style type="text/css">
*
{
  margin           : 0px;
  padding          : 0px;
}
#editor
{
  padding          : 2px;
  border           : 1px solid #666;
  background-color : #FFF;
  color            : #000;
  width            : 400px;
  height           : 43px;
  overflow         : hidden;
  font-size        : 10pt;
  text-align       : left;
}

img.icon
{
  border           : solid 1px #EEE;
  margin           : 0px;
  vertical-align   : top;
}
#file
{
  border           : solid 1px #F39;
  width            : 350px;
  height           : 47px;
  position         : absolute;
  top              : 0px;
  left             : 0px;
  font-size        : 14px;
  background-color : #FCF;
  display          : none;
  filter           : alpha(opacity=90);
}
body
{
  background-color : #EEE;
}
</style>
</head>
<body class="talkpage" id="body">

<form method="post" action="$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}?say" target="chat"$enctype>
  <input type="hidden" name="chat" value="" />
  <input type="hidden" name="html" value="1" />
  <input type="hidden" name="time" value="@{[time]}" />
  <input type="hidden" name="name" value="$::SIO{'name'}" />
  <input type="hidden" name="font" value="$::SIO{'font'}" />
  <input type="hidden" name="code" value="$::SIO{'code'}" />
  <input type="hidden" name="file" value="$::SIO{'file'}" />
  <input type="hidden" name="icon" value="$::SIO{'icon'}" />
  @{[$able{file} eq ""?'<input type="hidden" name="attachment" value="" />':""]}
  <div>
    <div style="float:left">
      <span id="editor" accesskey="c" contenteditable></span><input type="button" value="M" style="width:50px;height:50px" onclick="sendForm()" />
    </div>
    <div style="height:50px;vertical-align:middle">
      <div>
        <input type="button" value="ގ" onclick="logoutChat()" /> <select name="reload" onchange="return setReloadInterval(this)">
          <option value="0">蓮</option>
$reload_interval
          <option value="0">----</option>
          <option value="-1">Ҏ</option>
        </select>
      </div>
      <div style="font-size:14px">
        <input type="checkbox" name="use_effect" checked="checked" title="VFCNANeBuɃbZ[WMꍇɉo܂B" />ʉL
      </div>
    </div>
  </div>

  <div style="clear:both; height:25px; background-color:#EEE">
    <a href="#" onclick="return setCommand('bold')" title=" (B)" accesskey="b"><img src="$::SYS{'DOCS_DIR'}images/_bold.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a><a
       href="#" onclick="return setCommand('italic')" title="Α (I)" accesskey="i"><img src="$::SYS{'DOCS_DIR'}images/_italic.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a><a
       href="#" onclick="return setCommand('underline')" title=" (U)" accesskey="u"><img src="$::SYS{'DOCS_DIR'}images/_under.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a><a
       href="#" onclick="return setCommand('strikethrough')" title=" (S)" accesskey="s"><img src="$::SYS{'DOCS_DIR'}images/_strike.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a> <a
       href="#" onclick="return openColorDialog()" title="F"><img src="$::SYS{'DOCS_DIR'}images/_color.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a> <a
       href="#" onclick="return openBGColorDialog()" title="uy"><img src="$::SYS{'DOCS_DIR'}images/_bcolor.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a>
          <select onChange="setFontSize(this)">
            <option value="0">(TCY)</option>
            <option value="1">1 ()</option>
            <option value="2">2</option>
            <option value="3">3</option>
            <option value="4">4</option>
            <option value="5">5</option>
            <option value="6">6 ()</option>
          </select> <a
             href="#" onclick="return setLink()" title="nCp[N"><img src="$::SYS{'DOCS_DIR'}images/_link.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a> <a
             href="#" onclick="return removeFormat()" accesskey="c" title="(C)"><img src="$::SYS{'DOCS_DIR'}images/_cancel.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a> 
             <a href="#"$disable{dice} title="_CXU(D)" accesskey="d" onclick="return throw_dice()"><img src="$::SYS{'DOCS_DIR'}images/_dice.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a><a href="#"$disable{shake} title="VFCNM(H)" accesskey="h" onclick="return send_shake()"><img src="$::SYS{'DOCS_DIR'}images/_shake.gif" width="30" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a><a href="#"$disable{file} title="t@CM(F)" accesskey="f" onclick="return show_file_form()"><img src="$::SYS{'DOCS_DIR'}images/_file.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a><a href="#"$disable{picto} onclick="return open_pictograph()" accesskey="p" title="G}(P)"><img src="$::SYS{'DOCS_DIR'}images/_pictograph.gif" width="22" height="22" onmouseover="setIconBorder(this)" onmouseout="unsetIconBorder(this)" class="icon" /></a> $able{click}

  </div>
  <div id="file">
    <div style="background-color:#F39;color:#FFF;font-weight:bold;padding:2px;font-size:10px">t@CM <span style="font-weight:normal">(@{[getMeasure($::INI{'allow_upload'}*1024,0)]}B܂)</span></div>
    <div style="padding:2px 0px 2px 5px">
      <input type="file" name="attachment" size="40" /><input type="button" value="OK" onclick="show_file_form()" />
    </div>
  </div>
</form>
</body>
</html>
__HTML__

	} else {  		#  for other browsers
		print <<__HTML__;
<?xml version="1.0" encoding="$::JCODE2" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
<base href="http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<meta http-equiv="Content-Script-Type" content="text/javascript" />
$::LINK_ELEMENT
<title>$::INI{'title'}</title>
<script type="text/javascript">
<!--
var chat_uri = "$::SYS{'CHAT_DIR_URI'}$::SIO{'file'}.html?";
var docs_uri = "$::SYS{'DOCS_DIR_URI'}";
var send_uri = '$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}?@{[stdio::setQueryString(\%::SIO)]}';
var default_color= '$::SIO{'font'}';
//-->
</script>
<script type="text/javascript" src="$::SYS{'DOCS_DIR'}js/form.js">
</script>
<style type="text/css">
*
{
  margin             : 0px;
  padding            : 0px;
}
#editor
{
  padding            : 1px;
  height             : 16px;
  font-size          : 14px;
}
select
{
  padding            : 2px;
  height             : 21px;
}
.button
{
  border             : 1px solid #888;
  padding            : 2px;
  width              : 45px;
  height             : 22px;
  background-color   : #EEE;
}
div.options
{
  margin-top         : 1px;
  text-align         : right;
  font-size          : 13px;
}
</style>
</head>
<body $::INI{'body'} class="talkpage">

<form method="post" action="$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}?say" target="chat" onsubmit="return sendForm()"$enctype>
  <input type="hidden" name="name" value="$::SIO{'name'}" />
  <input type="hidden" name="time" value="@{[time]}" />
  <input type="hidden" name="code" value="$::SIO{'code'}" />
  <input type="hidden" name="font" value="$::SIO{'font'}" />
  <input type="hidden" name="file" value="$::SIO{'file'}" />
  <input type="hidden" name="icon" value="$::SIO{'icon'}" />
  <noscript>
    <input type="hidden" name="nojs" value="1" />
  </noscript>
  <div>
    <div style="height:24px;font-size:14px">
      <input name="chat" value="" size="60" maxlength="256" id="editor" accesskey="c" autocomplete="off" /><input type="submit" value="M" class="button" /><input type="submit" name="logout" value="ގ" class="button" onclick="return logoutChat()" /><select name="reload" style="width:65px" onchange="return setReloadInterval(this)">
        <option value="0">蓮</option>
$reload_interval
        <option value="0">----</option>
        <option value="-1">Ҏ</option>
      </select>
    </div>
__HTML__
		print <<__HTML__ if ("$able{picto}$able{shake}$able{dice}$able{click}" ne "");
    <div class="options">
      $able{picto}$able{shake}$able{dice} $able{click}
    </div>
__HTML__
		print <<__HTML__ ;
    <div class="options">
      $able{file}$able{html} <input type="checkbox" name="use_effect" accesskey="e" checked="checked" title="VFCNANeBuɃbZ[WMɉo܂B" />ʉL(<u>E</u>)
    </div>
  </div>
</form>
</body>
</html>
__HTML__

	}

	exit;

}#Show_TalkingPage

1;
