
#
#  - CHATTERS ver 1.00 / Feb 15, 2007 / Freesoft
#  - (C)2007 WEB POWER. All Rights Reserved. <http://webpower.jp/>
#

use strict;



#
# * Redirect to URI for hide referrer.
#
#     Called : *
#     Params : URI
#     Return : exit
#

sub redirect_to_out #($uri);
{

	# ->Parameters
	my($uri) = @_;

	header("nocache", "Refresh: 3; URL=$uri");
	print <<__HTML__;
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
<meta http-equiv="Content-Style-Type" content="text/css" />
<meta http-equiv="Content-Script-Type" content="text/javascript" />
<title>$::INI{'title'}</title>
</head>
<body>
<h1>΂炭҂</h1>

<p><a href="$uri">$uri</a> փWv悤ƂĂ܂BIɃWv܂̂ŁÂ܂܂҂B΂炭҂ĂWvȂꍇ̓NNbNĂB</p>
</body>
</html>
__HTML__

	exit;

}#redirect


#
#  oCgƌȂK؂ȎwPʂtĕԂ
#     (_2EJグP1024E1000ȏ͏ʒP)
#
#     ďo : talkChat, Show_TalkingPage
#        : oCg, _
#     ߂l : PʕtoCg
#

sub getMeasure #($byte)
{

	#  
	my($byte, $point) = @_;

	#  ! Ǐϐ錾
	my(@measure, $i);


	return $byte if (!$byte || $byte =~ /\D/);
	@measure = ("", "K", "M", "G", "T", "P", "E", "Z", "Y");
	$point = 2 if ($point eq "");
	for ($i = 0; $i <= $#measure; $i ++) {
		if ($byte < 1024) {
			if ($byte >= 1000) {
				return $byte . $measure[$i+1];
			} else {
				return $byte . $measure[$i];
			}
		}
		$byte = sprintf("%.${point}f", $byte / 1024);
	}
	return $byte . "Y";

}#getMeasure

#
#  fBNg̃TCYƃt@CԂ
#
#     ďo : talkChat
#        : fBNg̃pX[, (K\)]
#     ߂l : -1=fBNgI[vs / 0=TCY, t@C
#

sub getDirSize #($dir, $match)
{

	#  
	my($dir, $match) = @_;

	#  ! Ǐϐ錾 (int, string)
	my($size, $file);


	if (!opendir DIR, $dir) {
		return -1;
	}
	while ($_ = readdir DIR) {
		if (-f "$dir$_" && ($match eq "" || /$match/)) {
			$size += (-s "$dir$_");
			$file ++;
		}
	}

	return $size, $file;

}#getDirSize


#
#  [gzXg擾
#
#     ďo : *
#        : Ȃ
#     ߂l : Ȃ
#

sub getHost #(void)
{

	if ($ENV{'REMOTE_HOST'} eq $ENV{'REMOTE_ADDR'} || !$ENV{'REMOTE_HOST'}) {
		$ENV{'REMOTE_HOST'} = gethostbyaddr(pack('C4',split(/\./, $ENV{'REMOTE_ADDR'})),2);
		$ENV{'REMOTE_HOST'} = $ENV{'REMOTE_ADDR'} if (!$ENV{'REMOTE_HOST'});
	}

	return;

}#getHost


#
#  IPAhXstÍĎ擾
#
#     ďo : *
#        : Ȃ
#     ߂l : ÍIPAhX(8oCg)
#

sub getCryptedIP #(void)
{

	my($crypt_ip) = crypt(sprintf("%02X%02X%02X%02X", split(/\./, $ENV{'REMOTE_ADDR'})), substr($::CFG{'random_key'}, 16, 2));
	$crypt_ip =~ s/^(\$1\$..\$|..)//;
	$crypt_ip =~ tr/A-Za-z0-9//cd;
	$crypt_ip = substr $crypt_ip, 0, 8;
	if (length $crypt_ip < 8) {
		$crypt_ip .= "x" x (8 - length($crypt_ip));
	}

	return $crypt_ip;

}#getCryptedIP


#
#  mݒ肵Ĕz񂩂烉_1𒊏o
#
#      <<m(y)̋ߕ>>
#       Ef[^i[ꂽz̍ŏIvf̓Y  : n
#       EY(k)̔zvfɊi[ꂽmwl : k(x)
#       Em߂zvf̓Y            : i
#
#                i(x)
#         y =  
#                n
#                k(x)
#               k=0
#
#     ďo : Talk_Chat
#        : \@z
#                (zvfmwl(x):eLXg) (1x4096)
#                Zp[^[͐ȊO̔Cӕ
#     ߂l : oꂽvf(m̂)
#

sub getTextRandomly #($text_)
{

	#  
	my($text_) = @_;

	#  ! Ǐϐ錾
	my(@text2, $total, $rand);

	foreach (@{$text_}) {
		my($probability, $text) = split /\D/, $_, 2;
		next if ($probability =~ /\D/ || $probability > 4096 || !$probability);

		$total += $probability;
		push @text2, "$total:$text";
	}
	$rand = int(rand $total) + 1;
	foreach (@text2) {
		my($probability, $text_) = split /:/, $_, 2;
		return $text_ if ($rand <= $probability);
	}

	return;

}#getTextRandomly


#
#  i[hpGR[himgvfɒu
#
#     ďo : *
#        : 10iVtgJISGR[h or 16iUNICODEGR[h
#     ߂l : imgvf
#

sub getImage #($code)
{

	#   (string)
	my($code) = @_;


	if (-f "$::SYS{'DOCS_DIR'}pictographs/$code.png") {
		return qq|<img src="$::SYS{'DOCS_DIR'}pictographs/$code.png" width="12" height="12" border="0" alt="" />|;
	} elsif (-f "$::SYS{'DOCS_DIR'}pictographs/$code.gif") {
		return qq|<img src="$::SYS{'DOCS_DIR'}pictographs/$code.gif" width="12" height="12" border="0" alt="" />|;
	} else {
		return "&amp;#$code;"
	}

}#getImage


#
#  IPAhXƂɈقȂ郆j[NL[ݒ肷
#
#     ďo : Show_LoginPage, Login_Chat
#        : Ȃ
#     ߂l : Ȃ
#

sub getUniqueKey #(void)
{
	my($ipaddr, $salt);

	foreach (split /\./, $ENV{'REMOTE_ADDR'}, 4) {
		$ipaddr .= unpack("B8",  pack("C", $_));
	}
	$salt = substr($::CFG{'random_abc'}, ord(pack("B*", "00" . substr($ipaddr, 0, 6))), 1) . substr($::CFG{'random_abc'}, ord(pack("B*", "00" . substr($ipaddr, 6, 6))), 1);
	$::SYS{'UNIQUE_KEY'} = crypt(substr($::CFG{'random_key'}, 0, 8), $salt);
	$::SYS{'UNIQUE_KEY'} = $2 if ($::SYS{'UNIQUE_KEY'} =~ /^(\$1\$..\$|..)(.{8})/);
	$::SYS{'UNIQUE_KEY'}.= substr($::CFG{'random_key'}, 8, 8);

	return;

}#getUniqueKey


#
#  vIPAhXw肵IPAhX(Tulbgw)Ɉv邩mF
#
#     ďo : init, forbidAccess
#        : @IPAhX(:192.168.1.0/24)
#     ߂l : 1=v / 0=sv
#

sub checkIPaddr #($ipaddr, @ipaddr)
{

	#   (string)
	my(@ipaddr) = @_;

	#  ! Ǐϐ錾 (string)
	my($ipaddr);


	foreach (split /\./, $ENV{'REMOTE_ADDR'}, 4) {
		$ipaddr .= unpack("B8",  pack("C", $_));
	}

	a:foreach (@ipaddr) {
		my($ipaddr2, $ipaddr_bit2, $subnet_mask);
		($ipaddr2, $subnet_mask) = split /\//;
		foreach (split /\./, $ipaddr2, 4) {
			next a if ($_ >= 256 || $_ < 0);
			$ipaddr_bit2 .= unpack("B8",  pack("C", $_));
		}
		$ipaddr_bit2 = substr $ipaddr_bit2, 0, $subnet_mask if ($subnet_mask);
		return 1 if (index($ipaddr, $ipaddr_bit2) == 0);
	}
	return 0;

}#checkIPaddr


#
#  Perlt@Crequireœǂݍ (Ot)
#
#     ďo : *
#        : Perlt@C̃pX
#     ߂l : Ȃ (ǂݍ߂Ȃꍇ̓G[ďI)
#

sub include #($file)
{

	#   (string)
	my($file) = @_;


	return if ($INC{$file});
	if (!-f $file) {
		error("[A00]$file t@Co", "", "Cu(ݒt@C)oł܂ł");
	}
	eval { require $file; };
	if ($@) {
		error("[A00]$file O($@)", "", "Cu(ݒt@C)ǂݍݒɗO܂");
	}

	return;

}#include


#
#  X|Xwb_[o͂
#
#     ďo : *
#        : @wb_[ (Content-Type: text/html͕sv)
#     ߂l : Ȃ
#

sub header #(@headers)
{

	# 
	my(@headers) = @_;


	print "Content-Type: text/html" . $::CHARSET . "\n" if ($headers[0] !~ /^Content-Type:/i);
	print "Content-Encoding: $::SYS{'GZIP_TYPE'}\n" if ($::SYS{'GZIP_TYPE'});
	foreach (@headers) {
		if ($_ eq "nocache") {
			print "Cache-Control: no-cache\n"
				. "Pragma: no-cache\n";
		} elsif (/^(Expires|Last-Modified):\s*(d{10})$/i) {
			printf "$1: %s, %d %s %d %s GMT\n", (split / /, scalar(gmtime($2)))[0,2,1,4,3];
		} else {
			print "$_\n";
		}
	}
	print "\n";
	open STDOUT, "| $::SYS{'GZIP_PATH'} -1 -c" if ($::SYS{'GZIP_TYPE'});

	return;

}#header


#
#  t@CRs[
#
#     ďo : *
#        : Rs[t@C, Rs[t@C
#     ߂l : 0=s^1=
#

sub copyFile #($base_file, $new_file)
{

	#  
	my($base_file, $new_file) = @_;

	if (!open IN, $base_file) {
		return 0;
	} elsif (!open OUT, ">$new_file") {
		return 0;
	} else {
		my($buf);
		binmode IN;
		binmode OUT;
		while (read IN, $buf, 4096) {
			print OUT $buf;
		}
	}
	close OUT;
	close IN;

	return 1;

}#copyFile


#
#  Õy[W\
#
#     ďo : *
#        : G[R[h, G[^Cg1, G[^Cg2, G[bZ[W,
#                HTTPXe[^X, G[Ot@C̃pX(Ocꍇ)
#     ߂l : I
#

sub error #($err_type, $err_title1, $err_title2, $err_msg, $status, $log_file)
{

	#  
	my($err_type, $err_title1, $err_title2, $err_msg, $status, $log_file) = @_;


	#  [gzXg擾
	if ($ENV{'REMOTE_HOST'} eq $ENV{'REMOTE_ADDR'} || !$ENV{'REMOTE_HOST'}) {
		$ENV{'REMOTE_HOST'} = gethostbyaddr(pack('C4',split(/\./, $ENV{'REMOTE_ADDR'})),2);
		$ENV{'REMOTE_HOST'} = $ENV{'REMOTE_ADDR'} if (!$ENV{'REMOTE_HOST'});
	}

	# <VXeG[bZ[W>
	if ($err_title1 eq "") {			# ʓIȃVXeG[
		$err_title1 = "VXeG[܂";
		$err_title2 = "肪ߏI܂";
		$err_msg = <<__HTML__;
<p>
  T[o[CGIVXe̐ݒ肪ĂA͈ꎞIȃVXeQ̉\\܂B<br />
  ̖͌̓T[o[ɂAg̃uEU̐ݒ⑀ɂ̂ł͂܂B<br />
</p>
<p>
  fĐ\\󂠂܂B<br />
  ΂炭ԂĂēxANZXĂB肪Ȃꍇ́Aȉ̃G[YăTCgǗ҂ɘAĂB
</p>
__HTML__

	} elsif ($err_title1 eq "busy") {	# rɂVXeG[
		$err_title1 = "ܑύGĂ܂";
		$err_title2 = "΂炭҂[XV]Ă";
		$err_msg = <<__HTML__;
<p>
  ܃ANZXɏWĂAȂԂłB<br />
  ̖͌̓T[o[ɂAg̃uEU̐ݒ⑀ɂ̂ł͂܂B<br />
</p>
<p>
  fĐ\\󂠂܂B<br />
  [XV]ẲʂɂȂꍇ́AԂ炵ĂēxANZXĂB肪Ȃꍇ́Aȉ̃G[YăTCgǗ҂ɘAĂB
</p>
__HTML__

	} elsif ($err_msg ne "" && $err_msg !~ /^</) {
		$err_msg = "<p>$err_msg</p>";
	}
	$err_title2 = qq|<h2 class="err">$err_title2</h2>| if ($err_title2 ne "");
	# </VXeG[bZ[W>


	#  gѓdbpɑSpJ^Ji𔼊pɕϊ
	if ($::JCODE eq "sjis" && $ENV{'HTTP_USER_AGENT'} =~ /^(DoCoMo|J-PHONE|KDDI|UP\.Browser)/) {
		include($::SYS{'JCODE.PL'});
		$jcode::version = $jcode::version;
		if ($jcode::version) {
			jcode::z2h_sjis(\$err_type);
			jcode::z2h_sjis(\$err_title1);
			jcode::z2h_sjis(\$err_title2);
			jcode::z2h_sjis(\$err_msg);
		}
	}

	# HTML\Jn
	print "Content-Type: text/html", $::CHARSET, "\n";
	print "Status: $status" if ($status);
	print "Cache-Control: no-cache\n"
		. "Pragma: no-cache\n"
		. "\n";

	if ($ENV{'HTTP_USER_AGENT'} !~ /^(DoCoMo|J-PHONE|KDDI-|UP\.Browser)/) {
		print <<__HTML__; } else { print <<__HTML_FOR_MOBILE__; }
<?xml version="1.0" encoding="$::JCODE2" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
<meta http-equiv="Content-Style-Type" content="text/css" />
<meta http-equiv="Content-Script-Type" content="text/javascript" />
<title>VXeG[ [$err_type]</title>
<style type="text/css">
<!--

/*  bodyvf -------------------------- */
body, div, p
{
  font-family      : "lr oSVbN";
}
a:link
{
  color            : #00F;
  text-decoration  : none;
}
a:visited
{
  color            : #00F;
  text-decoration  : none;
}
a:hover
{
  color            : #00F;
  text-decoration  : underline;
}

/* -------------------------------------- */

div.bar
{
  background-color : #CCC;
  padding          : 4px;
  text-align       : center;
}
/* -------------------------------------- */

/*  G[S -------------------- */
div.err
{
  width            : 90%;
  margin-left      : auto;
  margin-right     : auto;
  margin-top       : 18px;
  border           : solid 1px #666;
  padding          : 0px;
  background-color : #FFD;
}
div.errbody
{
  margin           : 0px;
  padding          : 20px;
}
/* -------------------------------------- */

/*  NWbg -------------------- */
address.copyright
{
  font-size        : 8pt;
  font-family      : Arial;
  font-weight      : bold;
  font-style       : normal;
  margin-top       : 15px;
  margin-bottom    : 0px;
  text-align       : center;
}
/* -------------------------------------- */

/*  G[{ ------------------------ */
p
{
  font-size        : 12pt;
  padding-left     : 10px;
  padding-right    : 10px;
}
/* -------------------------------------- */

/*  G[^Cg -------------------- */
h1.err
{
  padding          : 7px;
  background-color : #F33;
  color            : #FFF;
  margin-top       : 0px;
  margin-bottom    : 0px;
  font-weight      : normal;
  font-size        : 19pt;
}
h2.err
{
  color            : #090;
  margin-top       : 5px;
  border-bottom    : dotted 2px #090;
  padding-bottom   : 2px;
  font-size        : 14pt;
}
h3.err
{
  color            : #800;
  border-left      : solid 8px #800;
  font-size        : 12pt;
  padding          : 6px;
  background-color : #CCC;
}
/* -------------------------------------- */

/*  G[e ------------------------ */
pre.err
{
  font-family      : "lr SVbN";
  border           : solid 1px #888;
  padding          : 2px;
  color            : #888;
  background-color : #EEE;
  font-size        : 8pt
}
/* -------------------------------------- */

-->
</style>
</head>
<body>

<div class="err">
<h1 class="err">$err_title1</h1>
<div class="errbody">
$err_title2
$err_msg
<div class="bar">
  <script type="text/javascript">
  <!--
    document.writeln('<a href="javascript:history.back()">[߂]</a> <a href="javascript:location.reload(true)">[Ďs]</a>');
  //-->
  </script>
  <noscript>uEU[߂]{^Ŗ߂Ă</noscript>
</div>
<pre class="err">
<strong>G[</strong>
$err_type ($::VERSION)
TIME  : @{[scalar gmtime(time)]} (GMT)
HOST  : $ENV{'REMOTE_HOST'} ($ENV{'REMOTE_ADDR'})
AGENT : $ENV{'HTTP_USER_AGENT'}
ERRMSG: $!</pre>

<address align="center" class="copyright">
  $::VERSION<br />
  Copyright&copy;2007 WEB POWER. All Rights Reserved.
</address>
</div>
</div>

</body>
</html>
__HTML__
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
<title>Ѵװ</title>
</head>
<body>
<h1><font color="#FF0000">$err_title1</font></h1>
$err_title2

$err_msg

<p>[[߂]Ŗ߂Ă</p>
<hr />
<p>
[C]$err_type($::VERSION)<br />
[U]$ENV{'HTTP_USER_AGENT'}<br />
[M]$!
</p>
</body>
</html>
__HTML_FOR_MOBILE__

	#  G[Oc
	if ($log_file) {
		if (open OUT, ">>$log_file") {
			print OUT "[" . scalar(gmtime(time+3600*9)) . "] [$err_type] [$ENV{'REMOTE_HOST'} ($ENV{'REMOTE_ADDR'}) [$ENV{'HTTP_USER_AGENT'}]\n";
			close OUT;
		}
	}

	exit;

}#error

1;
