



#
#  pX[h̐Ǝ㐫`FbN
#
#     ďo : *
#        : pX[h [, [U[]
#     ߂l : 1=Ȃ / 0=Ǝ㐫
#

sub check_PasswordSecurity #($password, $user_name)
{

	#  
	my($password, $username) = @_;

	#  ! Ǐϐ錾
	my(@password, %keybord, %ord, @word, $i);


	%keybord = qw(q  1 w  2 e  3 r	4 t  5 y  6 u  7 i	8 o  9 p 10
				  a 20 s 21 d 22 f 23 g 24 h 25 j 26 k 27 l 28
				  z 40 x 41 c 42 v 43 b 44 n 45 m 46);
	@word = qw(password passcode userid username fusiana google yahoo money inter pray with mime mail post mine apple orange banana auto train sample demo action final server work land train rail space check other secret frame html style
			   countory japan america england korea china france germany spain russia italy brazil canada australia swiss plane ocean ship desk chair many more most child parent tree thread adsl ftth catv icpo novel online offline room piano guitar hotel travel trip trouble matter milk water
			   test window door macintosh unix linux free giants note nippon nihon father mother daughter family young ebay calendar worry head body foot element king spade card queen club hand mouth life live addr conan break coffee choco laputa nausica mononoke dragon drink juice
			   week sunday monday tuesday wednesday thursday friday saturday calendar year time minute second public private home house true false casl million billion move link data base bath device myth hello good morning after evening dinner super supper biblo function method class object
			   month january februay march april june july august september october november december desk student school sage stop until moral manner rule express outlook visio high road load save delete bread snake lion zero tango atok message instant button submit reset gold
			   season spring summer fall winter soft warez crack hack krack back prev next your where this that these those while last finish over little mobile ketai docomo phone crypt print echo font size face know price prime kantei chubo under ground love stand volume
			   computer play staion cookie image kitchin robot site power spirit lycos excite info money digital analog byte visa master error miss plain text jpeg ping tiff midi acrobat peace pack holl golf ball basket cargo file search engine bidder
			   color black blue yellow green gray white purple olive silver maroon navy lime aqua perl java language ruby script prog welcome guest shikoku kinki kanto kansai chugoku hokuriku tokai tohoku hokkai kita minami higashi nishi news paper kuso baka boke nikkei
			   tokyo saitama yokohama kanagawa nigata nagano shizuoka shiga toyama ishikawa okayama hiroshima yamaguchi shimane tottori okinawa saga nagasaki oita kumamoto hyogo shima mori shinjuku akihabara akiba center chuo sapporo osaka kobe kyoto nara nagoya hakata fukuoka hawaii
			   word excel access photo micro just source soft hard auction shop digit number three four five saven eight nine eleven twelve teen pink shine cloud rain twenty return fist second third hundred fantasy evil english mouse moniter tray task mission control);

	@password = split //, lc $password;

	#  6ɖȂ
	if (length $password < 6) {
	   return 0;
	}

	#  ݂̂ō\
	if ($password =~ /^\d+$/) {
		return 0;
	}

	#  3ȏgpĂ (ex: aaaa cccd)
	foreach (@password) {
		my($ord) = ord;
		$ord{$ord} ++;
	}
	foreach (values %ord) {
		return 0 if ($_ >= 4);
	}

	#  R[h3Aŗׂ荇Ă (ex: abcd XYZ 456)
	for ($i = 0; $i <= length($password) - 3; $i ++) {
		my($ord1, $ord2, $ord3);
		$ord1 = ord($password[$i]);
		$ord2 = ord($password[$i+1]);
		$ord3 = ord($password[$i+2]);

		if ($ord2 == $ord1 && $ord3 == $ord2) {
			return 0;
		} elsif ($ord2 == $ord1 + 1 && $ord3 == $ord2 + 1) {
			return 0;
		} elsif ($ord2 == $ord1 - 1 && $ord3 == $ord2 - 1) {
			return 0;
		}
	}

	#  L[{[h3Aŗׂ荇Ă (ex: asdf jzxc)
	for ($i = 0; $i <= length($password) - 3; $i ++) {
		my($kbd1, $kbd2, $kbd3);
		$kbd1 = $keybord{$password[$i]};
		$kbd2 = $keybord{$password[$i+1]};
		$kbd3 = $keybord{$password[$i+2]};

		if ($kbd2 == $kbd1 + 1 && $kbd3 == $kbd2 + 1) {
			return 0;
		} elsif ($kbd2 == $kbd1 - 1 && $kbd3 == $kbd2 - 1) {
			return 0;
		}
	}

	#  [U[܂ or ]Ă
	if ($username) {
		my($username2) = $username;
		$username2 =~ tr/A-Z/a-z/;
		if ($password =~ /$username2/i || $username2 =~ /$password/i) {
			return 0;
		}
		$username2 = join "", reverse(split //, $username2);
		if ($password =~ /$username2/i || $username2 =~ /$password/i) {
			return 0;
		}
	}

	#  ɂ
	foreach (@word) {
		tr/021/ozl/;
		$password =~ tr/021/ozl/;
		if ($password =~ /^$_$/i || /$password/i) {
			return 0;
		}
	}

	return 1;

}#check_PasswordSecurity

1;
